// Copyright (C) 2005-2008 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include "complex-algorithm-pskel.hh"

namespace tmxsd
{
  // algorithm_pskel
  //

  void algorithm_pskel::
  name_parser (::tmxsd::char1k_pskel& p)
  {
    this->name_ = &p;
  }

  void algorithm_pskel::
  expression_parser (::tmxsd::char4k_pskel& p)
  {
    this->expression_ = &p;
  }

  void algorithm_pskel::
  index_parser (::xml_schema::unsigned_int_pskel& p)
  {
    this->index_ = &p;
  }

  void algorithm_pskel::
  module_id_parser (::xml_schema::unsigned_int_pskel& p)
  {
    this->module_id_ = &p;
  }

  void algorithm_pskel::
  module_index_parser (::xml_schema::unsigned_int_pskel& p)
  {
    this->module_index_ = &p;
  }

  void algorithm_pskel::
  comment_parser (::tmxsd::char4k_pskel& p)
  {
    this->comment_ = &p;
  }

  void algorithm_pskel::
  cut_parser (::tmxsd::cut_pskel& p)
  {
    this->cut_ = &p;
  }

  void algorithm_pskel::
  object_requirement_parser (::tmxsd::object_requirement_pskel& p)
  {
    this->object_requirement_ = &p;
  }

  void algorithm_pskel::
  external_requirement_parser (::tmxsd::external_requirement_pskel& p)
  {
    this->external_requirement_ = &p;
  }

  void algorithm_pskel::
  algorithm_id_parser (::tmxsd::id_pskel& p)
  {
    this->algorithm_id_ = &p;
  }

  void algorithm_pskel::
  datetime_parser (::tmxsd::datetime_pskel& p)
  {
    this->datetime_ = &p;
  }

  void algorithm_pskel::
  parsers (::tmxsd::char1k_pskel& name,
           ::tmxsd::char4k_pskel& expression,
           ::xml_schema::unsigned_int_pskel& index,
           ::xml_schema::unsigned_int_pskel& module_id,
           ::xml_schema::unsigned_int_pskel& module_index,
           ::tmxsd::char4k_pskel& comment,
           ::tmxsd::cut_pskel& cut,
           ::tmxsd::object_requirement_pskel& object_requirement,
           ::tmxsd::external_requirement_pskel& external_requirement,
           ::tmxsd::id_pskel& algorithm_id,
           ::tmxsd::datetime_pskel& datetime)
  {
    this->name_ = &name;
    this->expression_ = &expression;
    this->index_ = &index;
    this->module_id_ = &module_id;
    this->module_index_ = &module_index;
    this->comment_ = &comment;
    this->cut_ = &cut;
    this->object_requirement_ = &object_requirement;
    this->external_requirement_ = &external_requirement;
    this->algorithm_id_ = &algorithm_id;
    this->datetime_ = &datetime;
  }

  algorithm_pskel::
  algorithm_pskel ()
  : name_ (0),
    expression_ (0),
    index_ (0),
    module_id_ (0),
    module_index_ (0),
    comment_ (0),
    cut_ (0),
    object_requirement_ (0),
    external_requirement_ (0),
    algorithm_id_ (0),
    datetime_ (0),
    v_state_stack_ (sizeof (v_state_), &v_state_first_)
  {
  }
}

namespace tmxsd
{
  // algorithm_pskel
  //

  void algorithm_pskel::
  name (const std::string&)
  {
  }

  void algorithm_pskel::
  expression (const std::string&)
  {
  }

  void algorithm_pskel::
  index (unsigned int)
  {
  }

  void algorithm_pskel::
  module_id (unsigned int)
  {
  }

  void algorithm_pskel::
  module_index (unsigned int)
  {
  }

  void algorithm_pskel::
  comment (const std::string&)
  {
  }

  void algorithm_pskel::
  cut (const ::tmxsd::cut&)
  {
  }

  void algorithm_pskel::
  object_requirement (const ::tmxsd::object_requirement&)
  {
  }

  void algorithm_pskel::
  external_requirement (const ::tmxsd::external_requirement&)
  {
  }

  void algorithm_pskel::
  algorithm_id (unsigned int)
  {
  }

  void algorithm_pskel::
  datetime (const std::string&)
  {
  }
}

#include <cassert>

namespace tmxsd
{
  // Element validation and dispatch functions for algorithm_pskel.
  //
  bool algorithm_pskel::
  _start_element_impl (const ::xml_schema::ro_string& ns,
                       const ::xml_schema::ro_string& n,
                       const ::xml_schema::ro_string* t)
  {
    while (&t == 0) /* might be unused */;

    v_state_& vs = *static_cast< v_state_* > (this->v_state_stack_.top ());
    v_state_descr_* vd = vs.data + (vs.size - 1);

    if (vd->func == 0 && vd->state == 0)
    {
      if (this->::xml_schema::complex_content::_start_element_impl (ns, n, t))
        return true;
      else
        vd->state = 1;
    }

    while (vd->func != 0)
    {
      (this->*vd->func) (vd->state, vd->count, ns, n, t, true);

      vd = vs.data + (vs.size - 1);

      if (vd->state == ~0UL)
        vd = vs.data + (--vs.size - 1);
      else
        break;
    }

    if (vd->func == 0)
    {
      if (vd->state != ~0UL)
      {
        unsigned long s = ~0UL;

        if (n == "name" && ns.empty ())
          s = 0UL;

        if (s != ~0UL)
        {
          vd->count++;
          vd->state = ~0UL;

          vd = vs.data + vs.size++;
          vd->func = &algorithm_pskel::sequence_0;
          vd->state = s;
          vd->count = 0;

          this->sequence_0 (vd->state, vd->count, ns, n, t, true);
        }
        else
        {
          if (vd->count < 1UL)
            this->_expected_element (
              "", "name",
              ns, n);
          return false;
        }
      }
      else
        return false;
    }

    return true;
  }

  bool algorithm_pskel::
  _end_element_impl (const ::xml_schema::ro_string& ns,
                     const ::xml_schema::ro_string& n)
  {
    v_state_& vs = *static_cast< v_state_* > (this->v_state_stack_.top ());
    v_state_descr_& vd = vs.data[vs.size - 1];

    if (vd.func == 0 && vd.state == 0)
    {
      if (!::xml_schema::complex_content::_end_element_impl (ns, n))
        assert (false);
      return true;
    }

    assert (vd.func != 0);
    (this->*vd.func) (vd.state, vd.count, ns, n, 0, false);

    if (vd.state == ~0UL)
      vs.size--;

    return true;
  }

  void algorithm_pskel::
  _pre_e_validate ()
  {
    this->v_state_stack_.push ();
    static_cast< v_state_* > (this->v_state_stack_.top ())->size = 0;

    v_state_& vs = *static_cast< v_state_* > (this->v_state_stack_.top ());
    v_state_descr_& vd = vs.data[vs.size++];

    vd.func = 0;
    vd.state = 0;
    vd.count = 0;
  }

  void algorithm_pskel::
  _post_e_validate ()
  {
    v_state_& vs = *static_cast< v_state_* > (this->v_state_stack_.top ());
    v_state_descr_* vd = vs.data + (vs.size - 1);

    ::xml_schema::ro_string empty;
    while (vd->func != 0)
    {
      (this->*vd->func) (vd->state, vd->count, empty, empty, 0, true);
      assert (vd->state == ~0UL);
      vd = vs.data + (--vs.size - 1);
    }

    if (vd->count < 1UL)
      this->_expected_element (
        "", "name");

    this->v_state_stack_.pop ();
  }

  void algorithm_pskel::
  sequence_0 (unsigned long& state,
              unsigned long& count,
              const ::xml_schema::ro_string& ns,
              const ::xml_schema::ro_string& n,
              const ::xml_schema::ro_string* t,
              bool start)
  {
    while (&t == 0) /* might be unused */;

    switch (state)
    {
      case 0UL:
      {
        if (n == "name" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->name_;

            if (this->name_)
              this->name_->pre ();
          }
          else
          {
            if (this->name_)
            {
              const std::string& tmp (this->name_->post_char1k ());
              this->name (tmp);
            }

            count = 0;
            state = 1UL;
          }

          break;
        }
        else
        {
          assert (start);
          if (count < 1UL)
            this->_expected_element (
              "", "name",
              ns, n);
          count = 0;
          state = 1UL;
          // Fall through.
        }
      }
      case 1UL:
      {
        if (n == "expression" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->expression_;

            if (this->expression_)
              this->expression_->pre ();
          }
          else
          {
            if (this->expression_)
            {
              const std::string& tmp (this->expression_->post_char4k ());
              this->expression (tmp);
            }

            count = 0;
            state = 2UL;
          }

          break;
        }
        else
        {
          assert (start);
          if (count < 1UL)
            this->_expected_element (
              "", "expression",
              ns, n);
          count = 0;
          state = 2UL;
          // Fall through.
        }
      }
      case 2UL:
      {
        if (n == "index" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->index_;

            if (this->index_)
              this->index_->pre ();
          }
          else
          {
            if (this->index_)
            {
              unsigned int tmp (this->index_->post_unsigned_int ());
              this->index (tmp);
            }

            count = 0;
            state = 3UL;
          }

          break;
        }
        else
        {
          assert (start);
          if (count < 1UL)
            this->_expected_element (
              "", "index",
              ns, n);
          count = 0;
          state = 3UL;
          // Fall through.
        }
      }
      case 3UL:
      {
        if (n == "module_id" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->module_id_;

            if (this->module_id_)
              this->module_id_->pre ();
          }
          else
          {
            if (this->module_id_)
            {
              unsigned int tmp (this->module_id_->post_unsigned_int ());
              this->module_id (tmp);
            }

            count = 0;
            state = 4UL;
          }

          break;
        }
        else
        {
          assert (start);
          if (count < 1UL)
            this->_expected_element (
              "", "module_id",
              ns, n);
          count = 0;
          state = 4UL;
          // Fall through.
        }
      }
      case 4UL:
      {
        if (n == "module_index" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->module_index_;

            if (this->module_index_)
              this->module_index_->pre ();
          }
          else
          {
            if (this->module_index_)
            {
              unsigned int tmp (this->module_index_->post_unsigned_int ());
              this->module_index (tmp);
            }

            count = 0;
            state = 5UL;
          }

          break;
        }
        else
        {
          assert (start);
          if (count < 1UL)
            this->_expected_element (
              "", "module_index",
              ns, n);
          count = 0;
          state = 5UL;
          // Fall through.
        }
      }
      case 5UL:
      {
        if (n == "comment" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->comment_;

            if (this->comment_)
              this->comment_->pre ();
          }
          else
          {
            if (this->comment_)
            {
              const std::string& tmp (this->comment_->post_char4k ());
              this->comment (tmp);
            }

            count = 0;
            state = 6UL;
          }

          break;
        }
        else
        {
          assert (start);
          count = 0;
          state = 6UL;
          // Fall through.
        }
      }
      case 6UL:
      {
        if (n == "cut" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->cut_;

            if (this->cut_)
              this->cut_->pre ();
          }
          else
          {
            if (this->cut_)
            {
              const ::tmxsd::cut& tmp (this->cut_->post_cut ());
              this->cut (tmp);
            }

            count++;
          }

          break;
        }
        else
        {
          assert (start);
          count = 0;
          state = 7UL;
          // Fall through.
        }
      }
      case 7UL:
      {
        if (n == "object_requirement" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->object_requirement_;

            if (this->object_requirement_)
              this->object_requirement_->pre ();
          }
          else
          {
            if (this->object_requirement_)
            {
              const ::tmxsd::object_requirement& tmp (this->object_requirement_->post_object_requirement ());
              this->object_requirement (tmp);
            }

            count++;
          }

          break;
        }
        else
        {
          assert (start);
          count = 0;
          state = 8UL;
          // Fall through.
        }
      }
      case 8UL:
      {
        if (n == "external_requirement" && ns.empty ())
        {
          if (start)
          {
            this->::xml_schema::complex_content::context_.top ().parser_ = this->external_requirement_;

            if (this->external_requirement_)
              this->external_requirement_->pre ();
          }
          else
          {
            if (this->external_requirement_)
            {
              const ::tmxsd::external_requirement& tmp (this->external_requirement_->post_external_requirement ());
              this->external_requirement (tmp);
            }

            count++;
          }

          break;
        }
        else
        {
          assert (start);
          count = 0;
          state = ~0UL;
          // Fall through.
        }
      }
      case ~0UL:
        break;
    }
  }
}

namespace tmxsd
{
  // Attribute validation and dispatch functions for algorithm_pskel.
  //
  bool algorithm_pskel::
  _attribute_impl_phase_one (const ::xml_schema::ro_string& ns,
                             const ::xml_schema::ro_string& n,
                             const ::xml_schema::ro_string& s)
  {
    if (n == "algorithm_id" && ns.empty ())
    {
      if (this->algorithm_id_)
      {
        this->algorithm_id_->pre ();
        this->algorithm_id_->_pre_impl ();
        this->algorithm_id_->_characters (s);
        this->algorithm_id_->_post_impl ();
        unsigned int tmp (this->algorithm_id_->post_id ());
        this->algorithm_id (tmp);
      }

      return true;
    }

    if (n == "datetime" && ns.empty ())
    {
      if (this->datetime_)
      {
        this->datetime_->pre ();
        this->datetime_->_pre_impl ();
        this->datetime_->_characters (s);
        this->datetime_->_post_impl ();
        const std::string& tmp (this->datetime_->post_datetime ());
        this->datetime (tmp);
      }

      return true;
    }

    return false;
  }
}

namespace tmxsd
{
}

// Begin epilogue.
//
//
// End epilogue.

